\chapter{Introduction}

In which the history of this thesis is recounted.

% ASPN convergence / divergence / cycling behaviour

\section{Cycling in domain decomposition methods accelerated by Newton-Raphson}

This research began as an exploration of domain decomposition methods accelerated by Newton-Raphson.
Such methods can instead be thought of as Newton-Raphson preconditioned by domain decomposition methods.
However, we will use the first perspective exclusively.
The purpose of these methods is to solve differential equations, generally nonlinear ones, on domains that are either too complicated or too large to resolve with standard methods.

The domain is divided into subdomains and the problem solved on the subdomains.
These subdomains either overlap or meet at their boundaries.
The solution of a subdomain in the overlap regions or on the boundaries is shared amongst the subdomain's neighbours.
The problem is resolved on the subdomains using boundary conditions defined by this shared information.
This process is repeated until the solution agrees across all subdomains, called the global solution.

The iterative step, resolving the problem with new boundary conditions, can be accelerated by applying the Newton-Raphson method to it.
To do so, consider the boundary conditions on each subdomain as input to a function.
This function returns the boundary conditions found after solving the problem on each subdomain.
The derivative of the function can be found by solving a related problem on each subdomain.
Applying Newton-Raphson to this function will accelerate convergence towards the global solution, as long as the boundary conditions are near enough to those of the global solution.

This acceleration is expected to be an improvement on the convergence of domain decomposition methods, but there are no clear criteria for when it can cause divergence.
The original goal was to find such a set of criteria.
The focus of this research was on a specific method, namely alternating Schwarz preconditioned by Newton-Raphson (ASPN).

I began by looking for the set of criteria to guarantee convergence for Newton-Raphson when used to accelerate a fixed point iteration.
This provided necessary and, in certain cases, sufficient conditions for convergence.
Applying these criteria to ASPN resulted in an algorithm for guaranteed convergence of the method for nonlinear ODEs in 1D.

It also provided criteria to find counterexamples, ODEs for which ASPN converged to stable cycles.
Once one was found, with a sinusoidal nonlinearity, I was able to find others.

% Triangle intersection, incl. referee corrections

\section{Robust triangle intersection algorithm}

I was also tasked with fixing an apparent error in an algorithm that projected information between two nonmatching triangular grids.
An example was found where two overlapping triangles returned an empty intersection.
After investigating I found the intersection calculation had produced inconsistent results between its subfunctions.

I then wrote a new intersection algorithm intended to keep consistency between these subfunctions.
Primarily, the algorithm used a change of coordinates to keep all geometry consistent between calculations.
It also created a hierarchy in the type of points that can arise in intersection calculations.
Points higher in the hierarchy informed the number of points to find lower on the hierarchy.

This algorithm was submitted to Transactions on Mathematical Software, a journal published by the Association for Computing Machinery, for review.
The referees pointed out that this hierarchy was not sufficient for robustness.
While it ensured a given step was consistent with the preceding one, it did not provide self-consistency within that step.

To fix this, I examined the intersection calculations and found they needed to be paired together.
The position of the intersections are linked to one another in groups of two.
If one changes so too must another.
This provided the self-consistency of the steps missing from the first version.
This second version was ultimately accepted for publication.

% Generalization of triangle intersection algorithm

The principles used in the triangle intersection algorithm have wider ranging applications.
In particular, they can be applied to intersection algorithms for simplices in general dimension.
The same hierarchy applies, and the pairing of intersections becomes a linking of a varying number of intersections.

In this general dimension the implementation becomes significantly harder.
One must consider several factors, primarily how to enumerate all the calculations that need to take place.

% Kyrlov methods and equivalence with extrapolation methods

\section{Equivalence between extrapolation methods and Krylov methods}

I next explored the equivalence between extrapolation methods and Krylov methods.
Many of these equivalences were already known, and a primary goal was to codify them under a single framework.

It must be noted that Krylov methods are designed to solve linear problems.
Extrapolation methods instead accelerate sequences, including nonlinear ones.
When considering linear sequences the acceleration corresponds exactly to the search directions of certain Krylov methods.

Both types of methods can trace their underlying mechanisms to the multisecant equations, a set of equations that extends the secant method to higher dimensions.
These equations also underlie quasi-Newton methods, a type of root-finding method based on approximating Newton-Raphson in higher dimensions.

The final product of this research is a map showing the interconnectedness of these various methods.
This map should help identify methods that can be used to solve nonlinear problems using the same techniques as Krylov methods.
Since much machinery has been developed for these it would be beneficial to apply them throughout this tree of methods.